WKSContentListener Class Reference documentation

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Classes | Public Member Functions | Protected Member Functions | Protected Attributes | Private Member Functions | List of all members
WKSContentListener Class Reference

`#include <WKSContentListener.h>`

Inheritance diagram for WKSContentListener:

## Classes
struct | CellContent
| small class use to define a sheet cell content More...
struct | FormulaInstruction
| small class use to define a formula instruction More...

## Public Member Functions
| WKSContentListener (std::vector< WPSPageSpan > const &pageList, librevenge::RVNGSpreadsheetInterface *documentInterface)
virtual | ~WKSContentListener ()
void | setDocumentLanguage (int lcid)
void | startDocument ()
void | endDocument ()
void | handleSubDocument (WPSSubDocumentPtr &subDocument, libwps::SubDocumentType subDocumentType)
void | insertCharacter (uint8_t character)
| adds a basic character, .. More...
void | insertUnicode (uint32_t character)
| adds an unicode character More...
void | insertUnicodeString (librevenge::RVNGString const &str)
| adds a unicode string More...
void | insertTab ()
| adds an unicode character to a string ( with correct encoding ). More...
void | insertEOL (bool softBreak=false)
void | insertBreak (const uint8_t breakType)
void | setFont (const WPSFont &font)
| set the actual font More...
WPSFont const & | getFont () const
| returns the actual font More...
bool | isParagraphOpened () const
| returns true if a paragraph or a list is opened More...
void | setParagraph (const WPSParagraph &para)
| sets the actual paragraph More...
WPSParagraph const & | getParagraph () const
| returns the actual paragraph More...
void | insertField (WPSField const &field)
| adds a field More...
void | insertComment (WPSSubDocumentPtr &subDocument)
| adds comment More...
void | insertPicture (WPSPosition const &pos, const librevenge::RVNGBinaryData &binaryData, std::string type="image/pict", WPSGraphicStyle const &style=WPSGraphicStyle::emptyStyle())
| adds a picture in given position More...
void | insertObject (WPSPosition const &pos, const WPSEmbeddedObject &obj, WPSGraphicStyle const &style=WPSGraphicStyle::emptyStyle())
| adds an object with replacement picture in given position More...
void | insertPicture (WPSPosition const &pos, WPSGraphicShape const &shape, WPSGraphicStyle const &style)
| adds a picture in given position More...
void | insertTextBox (WPSPosition const &pos, WPSSubDocumentPtr subDocument, WPSGraphicStyle const &frameStyle=WPSGraphicStyle::emptyStyle())
| adds a textbox in given position More...
void | openSheet (std::vector< float > const &colWidth, librevenge::RVNGUnit unit, std::vector< int > const &repeatColWidthNumber=std::vector< int >(), librevenge::RVNGString const &name="")
| open a sheet More...
void | closeSheet ()
| closes this sheet More...
void | openSheetRow (float h, librevenge::RVNGUnit unit, bool headerRow=false, int numRepeated=1)
| open a row with given height. More...
void | closeSheetRow ()
| closes this row More...
void | openSheetCell (WPSCell const &cell, CellContent const &content, int numRepeated=1)
| low level function to define a cell. More...
void | closeSheetCell ()
| close a cell More...
Public Member Functions inherited from WPSListener
| WPSListener ()
virtual | ~WPSListener ()

## Protected Member Functions
void | _openPageSpan ()
void | _closePageSpan ()
void | _handleFrameParameters (librevenge::RVNGPropertyList &propList, WPSPosition const &pos)
bool | _openFrame (WPSPosition const &pos, WPSGraphicStyle const &style)
void | _closeFrame ()
void | _startSubDocument ()
void | _endSubDocument ()
void | _openParagraph ()
void | _closeParagraph ()
void | _appendParagraphProperties (librevenge::RVNGPropertyList &propList, const bool isListElement=false)
void | _resetParagraphState (const bool isListElement=false)
void | _openSpan ()
void | _closeSpan ()
void | _flushText ()
void | _flushDeferredTabs ()
void | _insertBreakIfNecessary (librevenge::RVNGPropertyList &propList)
shared_ptr< WKSContentParsingState > | _pushParsingState ()
| creates a new parsing state (copy of the actual state) More...
void | _popParsingState ()
| resets the previous parsing state More...

## Protected Attributes
shared_ptr< WKSDocumentParsingState > | m_ds
shared_ptr< WKSContentParsingState > | m_ps
std::vector< shared_ptr< WKSContentParsingState > > | m_psStack
librevenge::RVNGSpreadsheetInterface * | m_documentInterface

## Private Member Functions
| WKSContentListener (const WKSContentListener &)
WKSContentListener & | operator= (const WKSContentListener &)

## Constructor & Destructor Documentation

WKSContentListener::WKSContentListener | ( | std::vector< WPSPageSpan > const & | pageList,
|  | librevenge::RVNGSpreadsheetInterface * | documentInterface
| ) |  |

WKSContentListener::~WKSContentListener | ( |  | ) |
| virtual

WKSContentListener::WKSContentListener | ( | const WKSContentListener & |  | ) |
| private

## Member Function Documentation

void WKSContentListener::_appendParagraphProperties | ( | librevenge::RVNGPropertyList & | propList,
|  | const bool | isListElement = `false`
| ) |  |
| protected

Referenced by _openParagraph().

void WKSContentListener::_closeFrame | ( |  | ) |
| protected

Referenced by insertObject(), insertPicture(), and insertTextBox().

void WKSContentListener::_closePageSpan | ( |  | ) |
| protected

Referenced by endDocument().

void WKSContentListener::_closeParagraph | ( |  | ) |
| protected

Referenced by _closePageSpan(), _endSubDocument(), closeSheetCell(), endDocument(), insertBreak(), insertEOL(), and openSheet().

void WKSContentListener::_closeSpan | ( |  | ) |
| protected

Referenced by _closeParagraph(), _flushDeferredTabs(), insertComment(), and setFont().

void WKSContentListener::_endSubDocument | ( |  | ) |
| protected

Referenced by closeSheet(), and handleSubDocument().

void WKSContentListener::_flushDeferredTabs | ( |  | ) |
| protected

Referenced by insertCharacter(), insertEOL(), insertTab(), insertUnicode(), and insertUnicodeString().

void WKSContentListener::_flushText | ( |  | ) |
| protected

Referenced by _closeSpan(), _openFrame(), insertComment(), insertEOL(), insertField(), and insertTab().

void WKSContentListener::_handleFrameParameters | ( | librevenge::RVNGPropertyList & | propList,
|  | WPSPosition const & | pos
| ) |  |
| protected

Referenced by _closeFrame(), _openFrame(), and insertPicture().

void WKSContentListener::_insertBreakIfNecessary | ( | librevenge::RVNGPropertyList & | propList | ) |
| protected

Referenced by _appendParagraphProperties().

bool WKSContentListener::_openFrame | ( | WPSPosition const & | pos,
|  | WPSGraphicStyle const & | style
| ) |  |
| protected

Referenced by insertObject(), insertPicture(), and insertTextBox().

void WKSContentListener::_openPageSpan | ( |  | ) |
| protected

Referenced by _openParagraph(), and openSheet().

void WKSContentListener::_openParagraph | ( |  | ) |
| protected

Referenced by _openFrame(), _openSpan(), and insertComment().

void WKSContentListener::_openSpan | ( |  | ) |
| protected

Referenced by _flushDeferredTabs(), _openFrame(), insertCharacter(), insertEOL(), insertField(), insertUnicode(), and insertUnicodeString().

void WKSContentListener::_popParsingState | ( |  | ) |
| protected

resets the previous parsing state

Referenced by closeSheet(), and handleSubDocument().

shared_ptr< WKSContentParsingState > WKSContentListener::_pushParsingState | ( |  | ) |
| protected

creates a new parsing state (copy of the actual state)

Returns
  the old one

Referenced by handleSubDocument(), and openSheet().

void WKSContentListener::_resetParagraphState | ( | const bool | isListElement = `false` | ) |
| protected

Referenced by _openParagraph().

void WKSContentListener::_startSubDocument | ( |  | ) |
| protected

Referenced by handleSubDocument(), and openSheet().

void WKSContentListener::closeSheet | ( |  | ) |

closes this sheet

Referenced by _endSubDocument(), and endDocument().

void WKSContentListener::closeSheetCell | ( |  | ) |

close a cell

Referenced by openSheetCell().

void WKSContentListener::closeSheetRow | ( |  | ) |

closes this row

void WKSContentListener::endDocument | ( |  | ) |

WPSFont const & WKSContentListener::getFont | ( |  | ) | const
| virtual

returns the actual font

Implements WPSListener.

WPSParagraph const & WKSContentListener::getParagraph | ( |  | ) | const
| virtual

returns the actual paragraph

Implements WPSListener.

void WKSContentListener::handleSubDocument | ( | WPSSubDocumentPtr & | subDocument,
|  | libwps::SubDocumentType | subDocumentType
| ) |  |

Referenced by insertComment(), insertTextBox(), and WPSPageSpan::sendHeaderFooters().

void WKSContentListener::insertBreak | ( | const uint8_t | breakType | ) |
| virtual

Implements WPSListener.

void WKSContentListener::insertCharacter | ( | uint8_t | character | ) |
| virtual

adds a basic character, ..

Implements WPSListener.

void WKSContentListener::insertComment | ( | WPSSubDocumentPtr & | subDocument | ) |

adds comment

void WKSContentListener::insertEOL | ( | bool | softBreak = `false` | ) |
| virtual

Implements WPSListener.

void WKSContentListener::insertField | ( | WPSField const & | field | ) |
| virtual

adds a field

Implements WPSListener.

void WKSContentListener::insertObject | ( | WPSPosition const & | pos,
|  | const WPSEmbeddedObject & | obj,
|  | WPSGraphicStyle const & | style = `WPSGraphicStyle::emptyStyle()`
| ) |  |

adds an object with replacement picture in given position

Referenced by insertPicture().

void WKSContentListener::insertPicture | ( | WPSPosition const & | pos,
|  | const librevenge::RVNGBinaryData & | binaryData,
|  | std::string | type = `"image/pict"`,
|  | WPSGraphicStyle const & | style = `WPSGraphicStyle::emptyStyle()`
| ) |  |

adds a picture in given position

Referenced by insertObject(), and insertTextBox().

void WKSContentListener::insertPicture | ( | WPSPosition const & | pos,
|  | WPSGraphicShape const & | shape,
|  | WPSGraphicStyle const & | style
| ) |  |

adds a picture in given position

void WKSContentListener::insertTab | ( |  | ) |
| virtual

adds an unicode character to a string ( with correct encoding ).

Implements WPSListener.

void WKSContentListener::insertTextBox | ( | WPSPosition const & | pos,
|  | WPSSubDocumentPtr | subDocument,
|  | WPSGraphicStyle const & | frameStyle = `WPSGraphicStyle::emptyStyle()`
| ) |  |

adds a textbox in given position

Referenced by insertComment().

void WKSContentListener::insertUnicode | ( | uint32_t | character | ) |
| virtual

adds an unicode character

by convention if character=0xfffd(undef), no character is added

Implements WPSListener.

Referenced by insertCharacter().

void WKSContentListener::insertUnicodeString | ( | librevenge::RVNGString const & | str | ) |
| virtual

adds a unicode string

Implements WPSListener.

Referenced by insertField().

bool WKSContentListener::isParagraphOpened | ( |  | ) | const
| virtual

returns true if a paragraph or a list is opened

Implements WPSListener.

void WKSContentListener::openSheet | ( | std::vector< float > const & | colWidth,
|  | librevenge::RVNGUnit | unit,
|  | std::vector< int > const & | repeatColWidthNumber = `std::vector<int>()`,
|  | librevenge::RVNGString const & | name = `""`
| ) |  |

open a sheet

void WKSContentListener::openSheetCell | ( | WPSCell const & | cell,
|  | WKSContentListener::CellContent const & | content,
|  | int | numRepeated = `1`
| ) |  |

low level function to define a cell.

Parameters

  cell | the cell position, alignement, ...
  content | the cell content
  numRepeated | the cell columns repeatition

void WKSContentListener::openSheetRow | ( | float | h,
|  | librevenge::RVNGUnit | unit,
|  | bool | headerRow = `false`,
|  | int | numRepeated = `1`
| ) |  |

open a row with given height.

If h<0, use min-row-heigth

WKSContentListener& WKSContentListener::operator= | ( | const WKSContentListener & |  | ) |
| private

void WKSContentListener::setDocumentLanguage | ( | int | lcid | ) |
| virtual

Implements WPSListener.

void WKSContentListener::setFont | ( | const WPSFont & | font | ) |
| virtual

set the actual font

Implements WPSListener.

void WKSContentListener::setParagraph | ( | const WPSParagraph & | para | ) |
| virtual

sets the actual paragraph

Implements WPSListener.

void WKSContentListener::startDocument | ( |  | ) |

Referenced by _openPageSpan().

## Member Data Documentation

librevenge::RVNGSpreadsheetInterface* WKSContentListener::m_documentInterface
| protected

Referenced by _closeFrame(), _closePageSpan(), _closeParagraph(), _closeSpan(), _flushDeferredTabs(), _flushText(), _openFrame(), _openPageSpan(), _openParagraph(), _openSpan(), closeSheet(), closeSheetCell(), closeSheetRow(), endDocument(), insertComment(), insertEOL(), insertField(), insertObject(), insertPicture(), insertTextBox(), openSheet(), openSheetCell(), openSheetRow(), and startDocument().

shared_ptr<WKSDocumentParsingState> WKSContentListener::m_ds
| protected

Referenced by _openPageSpan(), _startSubDocument(), endDocument(), handleSubDocument(), openSheetCell(), setDocumentLanguage(), and startDocument().

shared_ptr<WKSContentParsingState> WKSContentListener::m_ps
| protected

Referenced by _appendParagraphProperties(), _closeFrame(), _closePageSpan(), _closeParagraph(), _closeSpan(), _endSubDocument(), _flushDeferredTabs(), _flushText(), _handleFrameParameters(), _insertBreakIfNecessary(), _openFrame(), _openPageSpan(), _openParagraph(), _openSpan(), _popParsingState(), _pushParsingState(), _resetParagraphState(), _startSubDocument(), closeSheet(), closeSheetCell(), closeSheetRow(), endDocument(), getFont(), getParagraph(), handleSubDocument(), insertBreak(), insertCharacter(), insertComment(), insertEOL(), insertTab(), insertUnicode(), insertUnicodeString(), isParagraphOpened(), openSheet(), openSheetCell(), openSheetRow(), setFont(), and setParagraph().

std::vector<shared_ptr<WKSContentParsingState> > WKSContentListener::m_psStack
| protected

Referenced by _popParsingState(), and _pushParsingState().

The documentation for this class was generated from the following files:

- WKSContentListener.h
- WKSContentListener.cpp